/********************************************************/
/*
	Player PRO 5.0 -- Music Driver EXAMPLE

	Library Version 5.0

	To use with Think C & CodeWarrior

	Antoine ROSSET
	16 Tranchees
	1206 GENEVA
	SWITZERLAND
	
	FAX: (+41 22) 346 11 97
	PHONE: (+41 79) 203 74 62
	Email: rossetantoine@bluewin.ch
*/
/********************************************************/

#include "RDriver.h"			// Mad Driver functions & globals

/*****************************/
/****** ERROR FUNCTION *******/
/*****************************/

void MyDebugStr( short, Ptr, Ptr)
{
}


void OSType2Ptr( OSType type, Ptr str)
{
	short i;
	
	BlockMoveData( &type, str, 4);
	str[ 4] = 0;
}

/*****************************/
/****** MAIN FUNCTION ********/
/*****************************/

void main( void)
{
Boolean					End = false;
MADDriverRec		*MADDriver;
MADMusic				*MADMusic;
MADLibrary			*MADLib;

/***************					****************/
/****** 	 	Toolbox Initialization	  **********/
/***************					****************/

InitGraf( &qd.thePort);
InitFonts();
InitWindows();
InitMenus();
TEInit();
InitDialogs(0L);
InitCursor();
MaxApplZone();
MoreMasters();

/*******************************************************************************************/
/****** MAD Library Initialisation : choose the best driver for the current hardware  ******/
/******																				  ******/
/****** Standard initialization with 4 channels...									  ******/
/*******************************************************************************************/

{
MADDriverSettings	init;


/*
MANUAL DRIVER CONFIGURATION, by example:

init.numChn				= 4;
init.outPutBits 		= 8;
init.outPutRate			= rate22khz;
init.outPutMode			= StereoOutPut;
init.driverMode			= SoundManagerDriver;
init.antiAliasing		= false;
init.repeatMusic		= false;
init.Interpolation		= false;
init.MicroDelay			= false;
init.MicroDelaySize 	= 35;
init.surround		 	= false;
init.sysMemory			= false;
init.Reverb				= false;
init.ReverbSize			= 45;
init.ReverbStrength		= 60;
init.ReverbStrength		= 60;
init.TickRemover		= false;
*/

/* or AUTOMATIC DRIVER CONFIGURATION FOR CURRENT MAC HARDWARE*/
MADGetBestDriver( &init);

if( MADInitLibrary( "Plugs", init.sysMemory, &MADLib) != noErr) DebugStr("\pSmall Problem...");
if( MADCreateDriver( &init, MADLib, &MADDriver) != noErr) DebugStr("\pSmall Problem...");
}
/*********************************/
/*********************************/
/*********************************/


MADStartDriver( MADDriver);				// Turn interrupt driver function ON

/****** Open a music file via Plugs ********/
while( End == false)
{
	StandardFileReply	reply;
	SFTypeList			aType;
	
	FlushEvents( everyEvent, 0);
	
	StandardGetFile( 0L, -1, aType, &reply);
	
	
	
	if( !reply.sfGood) End = true;
	else
	{
		char type[ 5];
		
		OSType2Ptr( reply.sfType, type);
		
		if( MADPlugAvailable( MADLib, type))		// Is available a plug to open this file?
		{
			if( MADLoadMusicFSpFile( MADLib, &MADMusic, type, &reply.sfFile) == noErr)		// Load this music with help of Plugs
																																										// in application folder, in 'Plugs' folder or internal resources
			{
				
				
				MADAttachDriverToMusic( MADDriver, MADMusic);
				MADPlayMusic( MADDriver);					// Read the current partition in memory
				
				while( !Button())
				{
					/// Do what you want here....
					/// Bla bla...
					/// By example:	Run your realtime 3D game
					///         	with 24bit texture mapping...
					
					long	fT, cT;
					
					MADGetMusicStatus( MADDriver, &fT, &cT);	// Some infos about current music
				}
				MADStopMusic( MADDriver);					// Stop reading current partition
				MADCleanDriver( MADDriver);
				MADDisposeMusic( &MADMusic, MADDriver);			// Dispose the current music
			}
		}
	}
}
MADStopDriver( MADDriver);				// Stop driver interrupt function
MADDisposeDriver( MADDriver);						// Dispose music driver
MADDisposeLibrary( MADLib);					// Close music library
FlushEvents( everyEvent, 0);			// Kill your events and byebye...
}